package be.iminds.ilabt.jfed.restapi.dropwizard;

import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.core.AppenderBase;

import java.util.Collection;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingDeque;

/**
 * jFedLoggingAppender
 */
public class JFedLoggingSiftedAppender extends JFedLoggingAppender {
    private final String mdcKey;
    private final String value;

    private static final int MAX_LOGGING_ENTRIES = 1_000;
    private final BlockingQueue<ILoggingEvent> log = new LinkedBlockingDeque<>(MAX_LOGGING_ENTRIES);

    public JFedLoggingSiftedAppender(String mdcKey, String value) {
        super();
        this.mdcKey = mdcKey;
        this.value = value;
    }

    public String getMdcKey() {
        return mdcKey;
    }

    public String getValue() {
        return value;
    }

    @Override
    protected void append(ILoggingEvent iLoggingEvent) {
        log.offer(iLoggingEvent);
    }

    public void drainTo(Collection<ILoggingEvent> collection) {
        log.drainTo(collection);
    }
}
